Bug 4352 - some text not displayed when setting antialias=false in fonts.conf
: some text not displayed when setting antialias=false in fonts.conf
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/seamonkey)
: unstable
: all Linux
: P2 normal
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2004-06-13 22:06 by
Modified: 2011-03-01 08:28 (History)


Attachments
screenshot demonstrating the bug (6.10 KB, image/png)
2004-06-13 22:11, Sergey Vlasov
no flags Details
HTML page demonstrating the bug (960 bytes, text/html)
2004-07-08 13:30, Sergey Vlasov
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2004-06-13 22:06:58
При попытке отключить сглаживание шрифтов через ~/.fonts.conf
mozilla-1.6-alt3.1
начинает ненормально отображать некоторые сайты (например,
http://www.securitylab.ru/): большая часть текста не отображается, однако
появляется при попытке его выделить; при плавной прокрутке текст появляется, но
при потере окном фокуса опять пропадает.

Проявляется даже с простейшим .fonts.conf и установленным ms-fonts-ttf:

<?xml version="1.0"?>
<!DOCTYPE fontconfig SYSTEM "fonts.dtd">
<fontconfig>
    <match target="font">
        <edit name="antialias" mode="assign">
            <bool>false</bool>
        </edit>
    </match>
</fontconfig>

Реально я пытался написать следующее правило:

    <match target="font">
        <test qual="any" name="family">
            <string>Arial</string>
            <string>Courier New</string>
            <string>Times New Roman</string>
            <string>Verdana</string>
            <string>Trebuchet MS</string>
            <string>Georgia</string>
            <string>Comic Sans MS</string>
            <string>Andale Mono</string>
            <string>Lucida Sans</string>
            <string>Lucida Sans Typewriter</string>
        </test>
        <test qual="any" name="pixelsize" compare="more_eq">
            <double>8</double>
        </test>
        <test qual="any" name="pixelsize" compare="less_eq">
            <double>18</double>
        </test>
        <edit name="hintstyle" mode="assign">
            <int>3</int>
        </edit>
        <edit name="antialias" mode="assign">
            <bool>false</bool>
        </edit>
    </match>

При убирании установки antialias текст отображается нормально.
------- Comment #1 From 2004-06-13 22:11:38 -------
Created an attachment (id=432) [details]
screenshot demonstrating the bug

Вот так выглядит http://www.securitylab.ru/ при попытке отключить сглаживание
шрифтов через ~/.fonts.conf.
------- Comment #2 From 2004-06-13 22:23:16 -------
Собственно, и без ms-fonts-ttf при отключении сглаживания текст точно так же не
отображается (просто другие шрифты без сглаживания выглядят довольно плохо).
------- Comment #3 From 2004-07-08 13:30:38 -------
Created an attachment (id=480) [details]
HTML page demonstrating the bug

Похоже, проблема появляется при указании letter-spacing в CSS.	Вот простой
пример, на котором это проявляется (отображается только первое слово в строке).
------- Comment #4 From 2005-07-19 18:52:32 -------
А что с этой багой ?
------- Comment #5 From 2005-07-19 18:57:13 -------
Бага актуальна.
------- Comment #6 From 2005-10-16 16:24:52 -------
У меня на 1.7.12 не воспроизводиться...
Закрываем?
------- Comment #7 From 2005-11-15 16:57:44 -------
Ни у кого нет возражений - закрываем.
------- Comment #8 From 2006-08-07 14:06:58 -------
На самом деле эта проблема никуда не делась, и точно так же проявляется ещё и в
firefox.  Проявляется на attachment (id=480) [details], нужно только отключить
сглаживание
шрифтов через .fonts.conf, и в настройках шрифтов выбрать какой-нибудь
TrueType-шрифт (при выборе растрового, типа Adobe Helvetica, текст отображается
нормально).

Ситуация напоминает bug #9830, но в данном случае проблема связана не с
libcairo, поскольку при обновлении этой библиотеки проблема не устраняется. 
Возможно, mozilla при рисовании текста делает что-то похожее самостоятельно?
------- Comment #9 From 2006-08-08 10:52:10 -------
mozilla-1.7.12-alt3.5 показывает
https://bugzilla.altlinux.org/attachment.cgi?id=480 некорректно, но
firefox-1.5.0.4-alt1 справляется.

Зато есть http://gpac.sourceforge.net/home_news.php - здесь лажаются оба. Как и
в самом исходном сообщении об ошибке, текст "проявляется" при попытке его
выделить или при плавной прокрутке страницы.
------- Comment #10 From 2006-08-08 17:03:51 -------
(In reply to comment #9)
> mozilla-1.7.12-alt3.5 показывает
> https://bugzilla.altlinux.org/attachment.cgi?id=480 некорректно, но
> firefox-1.5.0.4-alt1 справляется.

У меня именно firefox-1.5.0.4-alt1 показывает неправильно, если выбрать в
настройках шрифтов что-нибудь типа Arial или Verdana (нужен именно TrueType, для
которого отключено сглаживание).

> Зато есть http://gpac.sourceforge.net/home_news.php - здесь лажаются оба. Как и
> в самом исходном сообщении об ошибке, текст "проявляется" при попытке его
> выделить или при плавной прокрутке страницы.

Подтверждаю (там в стилях как раз font-family:Helvetica,Arial, sans-serif;
letter-spacing: 1px). Но в данном случае может быть важной версия и сборка
libfreetype (в разных сборках растровые шрифты Helvetica в формате pcf могли
называться либо Helvetica, либо Adobe Helvetica, а при использовании шрифтов pcf
эта проблема не проявляется).

Если использовать в .fonts.conf отключение сглаживания только для определённого
диапазона размеров, можно наблюдать, как при увеличении размера шрифтов через
Ctrl+KP_Plus текст после достижения размера, с которого включается сглаживание,
начинает отображаться нормально.
------- Comment #11 From 2006-08-08 17:23:41 -------
(In reply to comment #10)
> (In reply to comment #9)
> > mozilla-1.7.12-alt3.5 показывает
> > https://bugzilla.altlinux.org/attachment.cgi?id=480 некорректно, но
> > firefox-1.5.0.4-alt1 справляется.
> 
> У меня именно firefox-1.5.0.4-alt1 показывает неправильно, если выбрать в
> настройках шрифтов что-нибудь типа Arial или Verdana (нужен именно TrueType, для
> которого отключено сглаживание).

Никак не могу воспроизвести в firefox (ms-fonts-ttf с отключенным сглаживанием
для заданного диапазона от 7 до 16 пунктов) :(
------- Comment #12 From 2006-08-08 18:39:26 -------
В seamonkey-1.0.3 воспроизводится.
------- Comment #13 From 2006-08-08 22:37:09 -------
Похоже, это https://bugzilla.mozilla.org/show_bug.cgi?id=252033

(и там даже есть какой-то патч)
------- Comment #14 From 2006-08-08 23:46:21 -------
(In reply to comment #13)
> Похоже, это https://bugzilla.mozilla.org/show_bug.cgi?id=252033
> 
> (и там даже есть какой-то патч)

После пересборки firefox-1.5.0.4-alt1 с добавлением этого патча проблема исчезает.
------- Comment #15 From 2006-08-09 13:01:04 -------
bug #9863

Я видел этот патч в debian,когда собирал 1.5.0.6, но не прикладывал его. Раз эта
проблема действительно стоит так остро, то добалю его в следующей сборке.
------- Comment #16 From 2006-08-09 13:32:12 -------
(In reply to comment #14)
> (In reply to comment #13)
> > Похоже, это https://bugzilla.mozilla.org/show_bug.cgi?id=252033
> > 
> > (и там даже есть какой-то патч)
> 
> После пересборки firefox-1.5.0.4-alt1 с добавлением этого патча проблема исчезает.

И на http://gpac.sourceforge.net/home_news.php тоже?
------- Comment #17 From 2006-08-09 13:50:46 -------
(In reply to comment #15)
> bug #9863
> 
> Я видел этот патч в debian,когда собирал 1.5.0.6, но не прикладывал его. Раз эта
> проблема действительно стоит так остро, то добалю его в следующей сборке.

Во всяком случае, аналогичную проблему в libcairo (bug #9830) уже исправили
(точнее, это workaround - настоящая проблема кроется где-то в недрах xorg, но
когда её там найдут и исправят - неизвестно).

(In reply to comment #16)
> > После пересборки firefox-1.5.0.4-alt1 с добавлением этого патча проблема
исчезает.
> 
> И на http://gpac.sourceforge.net/home_news.php тоже?

Да, там тоже.
------- Comment #18 From 2006-08-09 14:05:48 -------
А этот баг я передаю мантейнеру.
------- Comment #19 From 2006-09-28 01:49:05 -------
Так что, в firefox попало?  А в seamonkey попадёт? :)
------- Comment #20 From 2006-09-28 09:34:53 -------
Выдержка из seamonkey changelog:

16 августа 2006 Damir Shayhutdinov <damir at altlinux.ru> 1:1.0.4-alt3 
- Added searching plugins in %browser_plugins_path
- Fixed pkgconfig and seamonkey-config (replaced /usr/lib/seamonkey-1.0.4 with /
usr/lib)
- Fixed #4352
------- Comment #21 From 2006-09-28 12:18:35 -------
(In reply to comment #19)
> Так что, в firefox попало?

http://gpac.sourceforge.net/home_news.php firefox-1.5.0.6-alt4
 - всё ещё наблюдаю проблему
------- Comment #22 From 2006-09-28 12:23:53 -------
(In reply to comment #21)
> (In reply to comment #19)
> > Так что, в firefox попало?
> 
> http://gpac.sourceforge.net/home_news.php firefox-1.5.0.6-alt4
>  - всё ещё наблюдаю проблему

firefox-1.5.0.7-alt1 - то же самое :-(
------- Comment #23 From 2006-09-28 12:36:33 -------
(In reply to comment #22)
> firefox-1.5.0.7-alt1 - то же самое :-(

Patch19: firefox-1.5.0.6-gtk2+xft-xrender-workaround.patch делает вид, что лежит
в пакете, но при сборке не прикладывается.
------- Comment #24 From 2006-09-28 12:40:46 -------
Проверьте в seamonkey пожалуйста.
------- Comment #25 From 2011-03-01 07:49:58 -------
Доброго времени.
Пробежался по приведенным примерам сайтов. Проблема не воспроизводится.
Прошу проверить, и если все хорошо, закрываем багу.
------- Comment #26 From 2011-03-01 08:28:48 -------
Ну, значит исправлено.